SystemOrganization addCategory: #'Physics-Core'!
SystemOrganization addCategory: #'Physics-View'!
SystemOrganization addCategory: #'Physics-Tests'!

Object subclass: #PhObject
	instanceVariableNames: 'origin velocity mass force'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Physics-Core'!

!PhObject class methodsFor: 'as yet unclassified' stamp: 'srh 12/13/2008 00:25'!
at: aPoint
	^self basicNew initialize; origin: aPoint; yourself.! !

!PhObject methodsFor: 'as yet unclassified' stamp: 'srh 12/13/2008 00:09'!
addForce: aForce
	force := force + aForce.! !

!PhObject methodsFor: 'as yet unclassified' stamp: 'srh 12/13/2008 00:17'!
applyForcesFor: aDuration
	origin := origin + ((force accelerationForMass: mass) * aDuration squared).
	force := PhForce new.! !

!PhObject methodsFor: 'as yet unclassified' stamp: 'srh 12/13/2008 00:18'!
initialize
	force := PhForce new.
	mass := 1.
	origin := 0@0.! !

!PhObject methodsFor: 'as yet unclassified' stamp: 'srh 12/13/2008 00:07'!
mass
	^mass! !

!PhObject methodsFor: 'as yet unclassified' stamp: 'srh 12/13/2008 00:26'!
origin: aPoint
	origin := aPoint.! !

!PhObject methodsFor: 'as yet unclassified' stamp: 'srh 12/12/2008 23:45'!
position
	^origin! !

Object subclass: #PhVector
	instanceVariableNames: 'magnitude direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Physics-Core'!

PhVector subclass: #PhForce
	instanceVariableNames: ''
	classVariableNames: 'Gravity'
	poolDictionaries: ''
	category: 'Physics-Core'!

!PhForce class methodsFor: 'as yet unclassified' stamp: 'srh 12/13/2008 00:05'!
gravityFor: anObject
	^self magnitude: (anObject mass) * Gravity direction: 180.! !

!PhForce class methodsFor: 'as yet unclassified' stamp: 'srh 12/13/2008 00:06'!
initialize
	super initialize.
	Gravity := 9.81! !

!PhForce class methodsFor: 'as yet unclassified' stamp: 'srh 12/13/2008 00:10'!
new
	^self basicNew initialize;yourself! !

!PhVector class methodsFor: 'as yet unclassified' stamp: 'srh 12/12/2008 23:59'!
magnitude: aMagnitude direction: aDirection
	^self new magnitude: aMagnitude; direction: aDirection;yourself! !

!PhVector class methodsFor: 'as yet unclassified' stamp: 'srh 12/13/2008 00:12'!
new
	^self basicNew initialize; yourself.! !

!PhVector methodsFor: 'accessing' stamp: 'srh 12/13/2008 00:02'!
angle
	^self direction! !

!PhVector methodsFor: 'accessing' stamp: 'srh 12/13/2008 00:01'!
direction
	^ direction! !

!PhVector methodsFor: 'accessing' stamp: 'srh 12/13/2008 00:01'!
direction: anObject 
	direction := anObject! !

!PhVector methodsFor: 'accessing' stamp: 'srh 12/13/2008 00:11'!
initialize
	super initialize.
	direction := 0.
	magnitude := 0.! !

!PhVector methodsFor: 'accessing' stamp: 'srh 12/13/2008 00:00'!
magnitude
	^ magnitude! !

!PhVector methodsFor: 'accessing' stamp: 'srh 12/13/2008 00:00'!
magnitude: anObject
	magnitude := anObject! !

Object subclass: #PhWorld
	instanceVariableNames: 'size forces objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Physics-Core'!

TestCase subclass: #PhForceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Physics-Tests'!

TestCase subclass: #PhObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Physics-Tests'!

!PhObjectTest methodsFor: 'as yet unclassified' stamp: 'srh 12/13/2008 00:24'!
testApplyForces1
	|o|
	o := PhObject at: 100@100.
	o addForce: (PhForce magnitude: 10 direction: 180).
	o applyForcesFor: 1 second.
	self assert: 100@90 equals: o position.! !
PhForce initialize!
